#include <stdlib.h>
#include <packet.h>
#include <plugin.h>
#include <decode.h>

#define DLT_EN10MB 1


int arp_decode(struct packet *);
int rarp_decode(struct packet *);

struct proto rarp_p=init_proto("rarp", rarp_decode);
struct proto_req rarp_r[]={
	proto_request("ethernet", __constant_htons(0x0835)),
	proto_request("sll", __constant_htons(0x0835)),
	proto_request("linux", __constant_htons(0x0835)),
	null_request()
};

struct proto arp_p=init_proto("arp", arp_decode);
struct proto_req arp_r[]={
	proto_request("ethernet", __constant_htons(0x0806)),
	proto_request("sll", __constant_htons(0x0806)),
	proto_request("linux", __constant_htons(0x0806)),
	null_request()
};

int arp_decode(struct packet *p){return 0;}
int rarp_decode(struct packet *p){return 0;}

int _PLUGIN_INIT (struct plugin_in *in, struct plugin_out *out)
{
	int ok=0;
	proc_decode_add decode_add;

	plugin_check(in, out);
	
	PLUGIN_ID("decode.arp", "ARP/RARP");
	PLUGIN_VERSION(2, 0);
	PLUGIN_AUTHOR("Gianni Tedesco", "gianni@ecsc.co.uk");
	PLUGIN_LICENSE("GPL");
	
	if ( !(decode_add=in->import("decode.add")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	ok+=decode_add(&arp_p, arp_r);
	ok+=decode_add(&rarp_p, rarp_r);
	
	return (ok) ? PLUGIN_ERR_OK : PLUGIN_ERR_FAIL;
}

int _PLUGIN_UNLOAD (int code) {
	return PLUGIN_ERR_OK;
}
