/*
* This file is part of Firestorm NIDS
* Copyright (c) 2002 Gianni Tedesco
* This program is released under the terms of the GNU GPL version 2
*
* 	This module handles the alerting subsystem. Although
* 	at the moment it passes all alerts straight on to the
* 	underlying target plugin - it will eventually support
* 	priority queuing so that non-critical alerts can be
* 	deferred.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <packet.h>
#include <sensor.h>
#include <capture.h>
#include <capdev.h>
#include <packet.h>
#include <target.h>
#include <alert.h>

struct output {
	struct output	*next;
	int		err;
	void		*t_priv;
	struct target	*target;
};

struct output *logs=NULL;
struct output *logs_tail=NULL;

/* TODO: Close and open all logs */
void alert_hup(void)
{
	return;
}

int alert_output(char *type, char *args)
{
	struct output *o;

	if ( !(o=malloc(sizeof(*o))) ) {
		return 0;
	}

	if ( !(o->target=target_find(type)) ) {
		free(o);
		return 0;
	}

	if ( !(o->target->validate(args, &o->t_priv)) ) {
		free(o);
		return 0;
	}

	o->next=NULL;
	o->err=0;
	if ( !logs ) {
		logs=o;
		logs_tail=o;
	}else{
		logs_tail->next=o;
		logs_tail=0;
	}

	return 1;
}

void alert(char *gen, struct packet *p, struct alert *a)
{
	struct output *l;

	if ( caught_hup ) {
		alert_hup();
		caught_hup=0;
	}
	
	/* Shitty builtin alerting function */
	if ( logs==NULL ) {
		printf("alert: %lu.%.6lu: %llu: %s: %s\n",
			p->time.tv_sec,
			p->time.tv_usec,
			p->serial,
			gen, a->alert);
		return;
	}

	for(l=logs; l; l=l->next) {
		if ( !l->err ) {
			l->target->target(gen, p,
				a->alert, l->t_priv);
		}else{
			printf("alert: error sending alert\n");
		}
	}
}
